#!/usr/bin/python
import sys
import vxi11
import time
import numpy as np

log_name = "dcl_10v_hulk_3458ac_nplc20_nov19.csv"

fluke = vxi11.Instrument("192.168.1.125", "gpib0,1") # Fluke 5720A, GPIB Address = 1
fluke.timeout = 30
#fluke.clear()
fluke.write("*IDN?")
print "Source detected = %s" % fluke.read()

dmm = vxi11.Instrument("192.168.1.125", "gpib0,2") # Keysight 3458A, GPIB Address = 1
dmm.timeout = 30
#dmm.clear()
#dmm.write("ID?")
#print "DUT1 detected = %s" % dmm.read()

dmm2 = vxi11.Instrument("192.168.1.125", "gpib0,7") # Keysight 3458A, GPIB Address = 1
dmm2.timeout = 30
#dmm2.clear()
#dmm2.write("ID?")
#print "DUT2 detected = %s" % dmm2.read()

#dmm3 = vxi11.Instrument("192.168.1.125", "gpib0,5") # Fluke 8508A, GPIB Address = 1
#dmm3.timeout = 30
#dmm3.clear()
#dmm3.write("*IDN?")
#print "DUT3 detected = %s" % dmm3.read()

#dmm4 = vxi11.Instrument("192.168.1.125", "gpib0,6") # Fluke 8508A, GPIB Address = 1
#dmm4.timeout = 30
#dmm4.clear()
#dmm4.write("*IDN?")
#print "DUT4 detected = %s" % dmm4.read("*IDN?")


dmm.write("BEEP")
dmm.write("END ALWAYS")
dmm.write("DCV 10")
dmm.write("NPLC 20")
dmm.write("NDIG 8")
dmm.write("TRIG AUTO")
dmm.write("MATH OFF")
print "DUT configured, starting ACAL"


dmm2.write("BEEP")
dmm2.write("END ALWAYS")
dmm2.write("DCV 10")
dmm2.write("NPLC 20")
dmm2.write("NDIG 8")
dmm2.write("TRIG AUTO")
dmm2.write("MATH OFF")
print "DUT2 configured, starting ACAL"

fluke.write("STBY")
fluke.write("RANGELCK OFF")
fluke.write("OUT 10 V, 0 Hz")
fluke.write("RANGELCK ON")
fluke.write("STBY")
fluke.write("OUT 0.0 V, 0 Hz")
fluke.write("EXTGUARD OFF")
fluke.write("OPER")
time.sleep(5)
print "SRC configured"

'''
dmm3.write("*RST")
dmm3.write("TRG_SRCE EXT")
dmm3.write("DCI 1000e-3,FILT_OFF,RESL7,FAST_OFF")
dmm3.write("GUARD INT")
dmm3.write("GATE FAST_OFF")
dmm3.write("AVG OFF")
dmm3.write("INPUT FRONT")
#dmm3.write("C LAST_RDG")
dmm3.write("SUB_C OFF")
print "DUT3 configured"
'''
'''
dmm4.write("*RST")
dmm4.write(":INIT:CONT OFF")
dmm4.write(":SYST:PRES")
dmm4.write(":FORM:ELEM READ")
dmm4.write(":SYST:AZER:STAT ON")
dmm4.write(":ABOR")
dmm4.write(":SENS:FUNC 'CURR:DC'")
dmm4.write(":SENS:CURR:DC:RANG 1000e-3")
dmm4.write(":SENS:CURR:DC:DIG 8")
dmm4.write(":SENS:CURR:DC:NPLC 50")
dmm4.write(":SENS:CURR:DC:AVER:STAT OFF")

dmm4.write("BEEP")
dmm4.write("END ALWAYS")
dmm4.write("DCV 10")
dmm4.write("NPLC 50")
dmm4.write("NDIG 8")
dmm4.write("TRIG AUTO")
dmm4.write("MATH OFF")
print "DUT4 configured"
'''

dmm.write("ACAL DCV")
dmm2.write("ACAL DCV")
#dmm4.write("ACAL DCV")
time.sleep(150)


'''
for vcnt in range (0,2):
    dmm3.write("*TRG;GET;RDG?")
    dmm3.read()
    dmm4.write("READ?") # Get reading
    dmm4.read()
'''
fluke.write("OUT 0.0 V")
fluke.write("OPER")
time.sleep(10)
for vcnt in range (0,10):
    dmm.write("TARM SGL")
    dmm.read()
    dmm2.write("TARM SGL")
    dmm2.read()
'''
dmm2.write("TARM SGL")
dmm2.read()
dmm4.write("TARM SGL")
dmm4.read()
'''
dmm.write("MATH NULL")
dmm2.write("MATH NULL")
'''
dmm2.write("MATH NULL")
dmm4.write("MATH NULL")
dmm3.write("SUB_C OFF") # Null math
'''
dmm2.write("TARM SGL") # Get reading
dmm2.read()
dmm.write("TARM SGL") # Get reading
dmm.read()
'''
dmm2.write("TARM SGL") # Get reading
dmm2.read()
dmm4.write("TARM SGL") # Get reading
dmm4.read()
#dmm3.write("*TRG;GET;RDG?") # Get reading
#dmm3.read()
print "DUTs is nulled to MFC zero"
'''
with open(log_name, 'a') as dile:
    dile.write ("date;source;duta;dutb;dutc;dutd;sdev;sdev2;sdev3;sdev4;temp;temp2\r\n")
dile.close()

vcnt = 0 # temporary counter
print "Log into %s started" % log_name

#set_value = 1.0000 #(float(i) / 100)
#fluke.write("OUT %.7g A" % set_value)
#print ("OUT %.7g A" % set_value)
#fluke.write("OPER")
    
invert = 0
icnt = 0
for i in range(-110,110,1):
    median = 0.0
    sdev = 0.0
    array = []
    median2 = 0.0
    sdev2 = 0.0
    array2 = []
    median3 = 0.0
    sdev3 = 0.0
    array3 = []
    median4 = 0.0
    sdev4 = 0.0
    array4 = []
    set_value = (float(i) / 10)
#    if (icnt >= 1000) and (invert == 0):
#	invert = 1
#	icnt = 0
#	fluke.write("OUT -1.00000 A")
#    if (icnt >= 1000) and (invert == 1):
#	invert = 0
#	icnt = 0
#	fluke.write("OUT 1.00000 A")
    fluke.write("OUT %.7g V" % set_value)
    fluke.write("OPER")
    time.sleep(5)
    for ix in range (0,5): #take more samples
	dmm.write("TARM SGL")
	val = float(dmm.read())
	dmm2.write("TARM SGL")
	val2 = float(dmm2.read())
	#dmm3.write("*TRG;GET;RDG?")
	val3 = 0#float(dmm3.read())
	#dmm4.write("FETC?")
	val4 = set_value * 1.000001#float(dmm4.read())
	array.extend([val])
	array2.extend([val2])
	array3.extend([val3])
	array4.extend([val4])
	if abs(set_value) >= 0.0000005:
	    print("\033[33;1mA %.8e, ppm %.4f \033[35;1mB %.8e SA, ppm %.4f \033[37;1mC %.8e, ppm %.4f \033[32;1mD %.8e, ppm %.4f\033[39;0m" % (val, ((val / set_value - 1) * 1e6), val2,(( (val2 ) /set_value - 1) * 1e6), val3,((val3 / set_value - 1) * 1e6),val4,((val4 / set_value - 1) * 1e6) ))
    	if (abs(val) >= 9.9e36) or (abs(val2) >= 9.9e36):
	    print ("Smoke escaped, check connections")
	    fluke.write("OUT 0 V")
	    fluke.write("STBY")
	    quit()
    icnt = icnt + 1
    
    sdev = np.std(array[3:])
    median = np.median(array[3:])
    sdev2 = np.std(array2[3:])
    median2 = np.median(array2[3:])
    sdev3 = np.std(array3[3:])
    median3 = np.median(array3[3:])
    sdev4 = np.std(array4[3:])
    median4 = np.median(array4[3:])
    if abs(float(i) / 10) >= 0.0000005:
	dev1 = ((median / set_value - 1) * 1e6)
	dev2 = ((median2 /set_value - 1) * 1e6)
	dev3 = ((median3 /set_value - 1) * 1e6)
	dev4 = ((median4 /set_value - 1) * 1e6)
	print("\033[32;1m SRC %.4f \033[33;1mA %.9e, sdev5 = %.3f uV, med5 = %.8f\033[35;1mB %.9e, sdev5 = %.3f uV, med5 = %.8e \033[34;1m Delta %.4f ppm \033[37;1mC %.9e, sdev5 = %.3f uV, med5 = %.8f\033[32;1m D %.9e, sdev5 = %.3f uV, med5 = %.8f\033[39;0m" % (set_value, val, sdev*1e6, median, val2,sdev2*1e6, median2, (dev1 - dev2),  val3,sdev3*1e6, median3, val4,sdev4*1e6, median4 ))
        #dmm.write("DISP MSG,'%5.3f %2.1fV" % (dev1,set_value ))
        #dmm2.write("DISP MSG,'%5.3f %2.1fV" % (dev2,set_value ))
    #dmm.write("TEMP?")
    temp = 24#float(dmm.read())
    #dmm2.write("TEMP?")
    temp2 = 24#float(dmm2.read())
    with open(log_name, 'a') as dile:
        dile.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%.4f;%.9e;%.9e;%.9e;%.9e;%.6g;%.6g;%.6g;%.6g;%.9e;%.1f\r\n" % (set_value, median, median2, median3, median4, sdev, sdev2, sdev3, sdev4, temp, temp2)))
    dile.close()

fluke.write("STBY")
fluke.write("OUT 0 V")
fluke.write("RANGELCK OFF")
dmm.write("RESET")
dmm2.write("RESET")
#dmm3.write("*RST")
#dmm4.write("*RST")
